/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ID = 258,
     OP = 259,
     ADD = 260,
     SUBTRACT = 261,
     TIMES = 262,
     DIVIDE = 263,
     MOD = 264,
     EXPONENT = 265,
     DOTS = 266,
     COLONS = 267,
     DASHES = 268,
     INCR = 269,
     LONGDASH = 270,
     CONTROLS = 271,
     TENSION = 272,
     ATLEAST = 273,
     CURL = 274,
     CYCLE = 275,
     COR = 276,
     CAND = 277,
     EQ = 278,
     NEQ = 279,
     LT = 280,
     LE = 281,
     GT = 282,
     GE = 283,
     CARETS = 284,
     AMPERSAND = 285,
     LOGNOT = 286,
     OPERATOR = 287,
     STRING = 288,
     LOOSE = 289,
     ASSIGN = 290,
     DIRTAG = 291,
     JOIN_PREC = 292,
     AND = 293,
     ELLIPSIS = 294,
     ACCESS = 295,
     UNRAVEL = 296,
     IMPORT = 297,
     INCLUDE = 298,
     FROM = 299,
     QUOTE = 300,
     STRUCT = 301,
     TYPEDEF = 302,
     NEW = 303,
     IF = 304,
     ELSE = 305,
     WHILE = 306,
     DO = 307,
     FOR = 308,
     BREAK = 309,
     CONTINUE = 310,
     RETURN_ = 311,
     STATIC = 312,
     THIS = 313,
     EXPLICIT = 314,
     LIT = 315,
     PERM = 316,
     MODIFIER = 317,
     UNARY = 318
   };
#endif
#define ID 258
#define OP 259
#define ADD 260
#define SUBTRACT 261
#define TIMES 262
#define DIVIDE 263
#define MOD 264
#define EXPONENT 265
#define DOTS 266
#define COLONS 267
#define DASHES 268
#define INCR 269
#define LONGDASH 270
#define CONTROLS 271
#define TENSION 272
#define ATLEAST 273
#define CURL 274
#define CYCLE 275
#define COR 276
#define CAND 277
#define EQ 278
#define NEQ 279
#define LT 280
#define LE 281
#define GT 282
#define GE 283
#define CARETS 284
#define AMPERSAND 285
#define LOGNOT 286
#define OPERATOR 287
#define STRING 288
#define LOOSE 289
#define ASSIGN 290
#define DIRTAG 291
#define JOIN_PREC 292
#define AND 293
#define ELLIPSIS 294
#define ACCESS 295
#define UNRAVEL 296
#define IMPORT 297
#define INCLUDE 298
#define FROM 299
#define QUOTE 300
#define STRUCT 301
#define TYPEDEF 302
#define NEW 303
#define IF 304
#define ELSE 305
#define WHILE 306
#define DO 307
#define FOR 308
#define BREAK 309
#define CONTINUE 310
#define RETURN_ 311
#define STATIC 312
#define THIS 313
#define EXPLICIT 314
#define LIT 315
#define PERM 316
#define MODIFIER 317
#define UNARY 318




/* Copy the first part of user declarations.  */
#line 1 "camp.y"

/*****
 * camp.y
 * Andy Hammerlindl 08/12/2002
 *
 * The grammar of the camp language.
 *****/

#include "errormsg.h"
#include "exp.h"
#include "newexp.h"
#include "dec.h"
#include "fundec.h"
#include "stm.h"
#include "modifier.h"

// Avoid error messages with unpatched bison-1.875:
#ifndef __attribute__
#define __attribute__(x)
#endif

// Used when a position needs to be determined and no token is
// available.  Defined in camp.l.
position lexerPos();

int yylex(void); /* function prototype */

void yyerror(const char *s)
{
  em->error(lexerPos());
  *em << s;
  em->sync();
}

namespace absyntax { file *root; }

using namespace absyntax;
using sym::symbol;


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 41 "camp.y"
typedef union YYSTYPE {
  position pos;
  //sym::symbol *sym;
  struct {
    position pos;
    sym::symbol *sym;
  } ps;
  absyntax::name *n;
  absyntax::varinit *vi;
  absyntax::arrayinit *ai;
  absyntax::exp *e;
  absyntax::specExp *se;
  absyntax::joinExp *j;
  absyntax::explist *elist;
  absyntax::argument arg;
  absyntax::arglist *alist;
  absyntax::dimensions *dim;
  absyntax::ty  *t;
  absyntax::decid *di;
  absyntax::decidlist *dil;
  absyntax::decidstart *dis;
  absyntax::runnable *run;
  struct {
    position pos;
    trans::permission val;
  } perm;
  struct {
    position pos;
    trans::modifier val;
  } mod;
  absyntax::modifierList *ml;
  //absyntax::program *prog;
  absyntax::vardec *vd;
  //absyntax::vardecs *vds;
  absyntax::dec *d;
  absyntax::idpair *ip;
  absyntax::idpairlist *ipl;
  absyntax::stm *s;
  absyntax::block *b;
  absyntax::stmExpList *sel;
  //absyntax::funheader *fh;
  absyntax::formal *fl;
  absyntax::formals *fls;
} YYSTYPE;
/* Line 190 of yacc.c.  */
#line 287 "camp.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 213 of yacc.c.  */
#line 299 "camp.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2247

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  81
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  49
/* YYNRULES -- Number of rules. */
#define YYNRULES  197
/* YYNRULES -- Number of states. */
#define YYNSTATES  381

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   318

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    35,     2,     2,
      49,    50,    33,    30,    52,    32,    51,    34,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    43,    55,
       2,     2,     2,    41,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    53,     2,    54,    36,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    46,     2,    48,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    31,    37,    38,    39,    40,
      42,    44,    45,    47,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     6,     9,    10,    13,    15,    19,
      21,    23,    26,    29,    31,    33,    36,    39,    41,    43,
      45,    49,    55,    61,    65,    71,    77,    81,    85,    89,
      91,    95,    97,   101,   103,   105,   107,   111,   113,   117,
     120,   123,   125,   128,   130,   133,   137,   141,   146,   148,
     152,   154,   158,   160,   163,   167,   172,   174,   176,   180,
     183,   188,   192,   198,   200,   202,   205,   207,   211,   213,
     217,   220,   222,   226,   228,   231,   236,   239,   243,   249,
     255,   262,   269,   273,   276,   280,   285,   290,   294,   299,
     303,   308,   312,   314,   316,   320,   322,   326,   329,   331,
     335,   337,   339,   341,   343,   346,   351,   357,   360,   363,
     366,   370,   374,   378,   382,   386,   390,   394,   398,   402,
     406,   410,   414,   418,   422,   426,   430,   434,   438,   441,
     445,   450,   454,   459,   465,   472,   479,   487,   493,   497,
     503,   511,   525,   529,   533,   536,   539,   542,   545,   549,
     553,   557,   561,   565,   569,   574,   576,   578,   581,   584,
     588,   593,   597,   603,   611,   613,   617,   621,   623,   625,
     628,   633,   637,   643,   646,   651,   653,   655,   658,   664,
     672,   678,   686,   696,   699,   702,   705,   709,   711,   713,
     714,   716,   718,   719,   721,   722,   724,   726
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
      82,     0,    -1,    83,    -1,    -1,    83,    86,    -1,    -1,
      84,    86,    -1,     3,    -1,    85,    51,     3,    -1,    88,
      -1,   123,    -1,    87,    88,    -1,    87,   123,    -1,    79,
      -1,    78,    -1,    87,    79,    -1,    87,    78,    -1,    94,
      -1,   111,    -1,   112,    -1,    57,    93,    55,    -1,    61,
      85,    58,    90,    55,    -1,    61,    85,    58,    33,    55,
      -1,    58,    85,    55,    -1,    61,    91,    57,    90,    55,
      -1,    61,    91,    57,    33,    55,    -1,    59,    92,    55,
      -1,    60,     3,    55,    -1,    60,    39,    55,    -1,     3,
      -1,     3,     3,     3,    -1,    89,    -1,    90,    52,    89,
      -1,    39,    -1,     3,    -1,     3,    -1,    91,     3,     3,
      -1,    92,    -1,    93,    52,    92,    -1,    95,    55,    -1,
      96,   100,    -1,    97,    -1,    85,    98,    -1,    85,    -1,
      53,    54,    -1,    98,    53,    54,    -1,    53,   117,    54,
      -1,    99,    53,   117,    54,    -1,   101,    -1,   100,    52,
     101,    -1,   102,    -1,   102,    42,   103,    -1,     3,    -1,
       3,    98,    -1,     3,    49,    50,    -1,     3,    49,   108,
      50,    -1,   117,    -1,   105,    -1,    46,    84,    48,    -1,
      46,    48,    -1,    46,    56,   103,    48,    -1,    46,   106,
      48,    -1,    46,   106,    56,   103,    48,    -1,    52,    -1,
     107,    -1,   107,    52,    -1,   103,    -1,   107,    52,   103,
      -1,   109,    -1,   109,    56,   110,    -1,    56,   110,    -1,
     110,    -1,   109,    52,   110,    -1,    96,    -1,    96,   102,
      -1,    96,   102,    42,   103,    -1,    76,    96,    -1,    76,
      96,   102,    -1,    76,    96,   102,    42,   103,    -1,    96,
       3,    49,    50,   125,    -1,    96,     3,    49,   108,    50,
     125,    -1,    96,     4,    49,   108,    50,   125,    -1,    63,
       3,   104,    -1,    64,    94,    -1,   113,    51,     3,    -1,
      85,    53,   117,    54,    -1,   113,    53,   117,    54,    -1,
      85,    49,    50,    -1,    85,    49,   115,    50,    -1,   113,
      49,    50,    -1,   113,    49,   115,    50,    -1,    49,   117,
      50,    -1,    75,    -1,   117,    -1,     3,    42,   117,    -1,
     116,    -1,   116,    56,   114,    -1,    56,   114,    -1,   114,
      -1,   116,    52,   114,    -1,    85,    -1,   113,    -1,    77,
      -1,    39,    -1,    77,   117,    -1,    49,    85,    50,   117,
      -1,    49,    85,    98,    50,   117,    -1,    30,   117,    -1,
      32,   117,    -1,    37,   117,    -1,   117,    30,   117,    -1,
     117,    32,   117,    -1,   117,    33,   117,    -1,   117,    34,
     117,    -1,   117,    35,   117,    -1,   117,    36,   117,    -1,
     117,    25,   117,    -1,   117,    26,   117,    -1,   117,    27,
     117,    -1,   117,    28,   117,    -1,   117,    23,   117,    -1,
     117,    24,   117,    -1,   117,    22,   117,    -1,   117,    21,
     117,    -1,   117,    29,   117,    -1,   117,    31,   117,    -1,
     117,    38,   117,    -1,   117,    14,   117,    -1,    65,    97,
      -1,    65,    97,    99,    -1,    65,    97,    99,    98,    -1,
      65,    97,    98,    -1,    65,    97,    98,   105,    -1,    65,
      97,    49,    50,   125,    -1,    65,    97,    98,    49,    50,
     125,    -1,    65,    97,    49,   108,    50,   125,    -1,    65,
      97,    98,    49,   108,    50,   125,    -1,   117,    41,   117,
      43,   117,    -1,   117,    42,   117,    -1,    49,   117,    52,
     117,    50,    -1,    49,   117,    52,   117,    52,   117,    50,
      -1,    49,   117,    52,   117,    52,   117,    52,   117,    52,
     117,    52,   117,    50,    -1,   117,   118,   117,    -1,   117,
     118,    20,    -1,   117,   119,    -1,    14,   117,    -1,    13,
     117,    -1,   117,    14,    -1,   117,     5,   117,    -1,   117,
       6,   117,    -1,   117,     7,   117,    -1,   117,     8,   117,
      -1,   117,     9,   117,    -1,   117,    10,   117,    -1,    62,
      46,    83,    48,    -1,    13,    -1,   120,    -1,   119,   120,
      -1,   120,   119,    -1,   119,   120,   119,    -1,    46,    19,
     117,    48,    -1,    46,   117,    48,    -1,    46,   117,    52,
     117,    48,    -1,    46,   117,    52,   117,    52,   117,    48,
      -1,    11,    -1,    11,   121,    11,    -1,    11,   122,    11,
      -1,    12,    -1,    15,    -1,    17,   117,    -1,    17,   117,
      47,   117,    -1,    17,    18,   117,    -1,    17,    18,   117,
      47,   117,    -1,    16,   117,    -1,    16,   117,    47,   117,
      -1,    55,    -1,   125,    -1,   124,    55,    -1,    66,    49,
     117,    50,   123,    -1,    66,    49,   117,    50,   123,    67,
     123,    -1,    68,    49,   117,    50,   123,    -1,    69,   123,
      68,    49,   117,    50,    55,    -1,    70,    49,   126,    55,
     127,    55,   128,    50,   123,    -1,    71,    55,    -1,    72,
      55,    -1,    73,    55,    -1,    73,   117,    55,    -1,   117,
      -1,   104,    -1,    -1,   129,    -1,    95,    -1,    -1,   117,
      -1,    -1,   129,    -1,   124,    -1,   129,    52,   124,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   167,   167,   171,   172,   177,   178,   183,   184,   197,
     198,   199,   201,   206,   207,   208,   210,   215,   216,   217,
     218,   220,   222,   224,   225,   227,   229,   231,   232,   237,
     239,   243,   244,   249,   250,   254,   256,   260,   261,   266,
     270,   274,   279,   283,   289,   290,   294,   295,   300,   301,
     306,   307,   312,   313,   314,   316,   321,   322,   326,   331,
     332,   334,   336,   341,   342,   343,   347,   349,   354,   355,
     357,   361,   362,   367,   368,   369,   371,   373,   375,   380,
     382,   384,   389,   390,   395,   396,   398,   399,   402,   406,
     407,   410,   412,   416,   417,   421,   422,   424,   428,   429,
     442,   443,   444,   445,   447,   451,   455,   457,   459,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   486,
     488,   490,   492,   494,   496,   501,   503,   508,   510,   512,
     514,   516,   518,   520,   524,   530,   532,   535,   537,   538,
     540,   541,   542,   543,   545,   552,   553,   555,   558,   561,
     567,   568,   569,   572,   578,   579,   581,   583,   584,   588,
     590,   593,   596,   602,   603,   608,   609,   610,   611,   613,
     615,   617,   619,   621,   622,   623,   624,   628,   632,   636,
     637,   638,   642,   643,   647,   648,   652,   653
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ID", "OP", "ADD", "SUBTRACT", "TIMES",
  "DIVIDE", "MOD", "EXPONENT", "DOTS", "COLONS", "DASHES", "INCR",
  "LONGDASH", "CONTROLS", "TENSION", "ATLEAST", "CURL", "CYCLE", "COR",
  "CAND", "EQ", "NEQ", "LT", "LE", "GT", "GE", "CARETS", "'+'",
  "AMPERSAND", "'-'", "'*'", "'/'", "'%'", "'^'", "LOGNOT", "OPERATOR",
  "STRING", "LOOSE", "'?'", "ASSIGN", "':'", "DIRTAG", "JOIN_PREC", "'{'",
  "AND", "'}'", "'('", "')'", "'.'", "','", "'['", "']'", "';'",
  "ELLIPSIS", "ACCESS", "UNRAVEL", "IMPORT", "INCLUDE", "FROM", "QUOTE",
  "STRUCT", "TYPEDEF", "NEW", "IF", "ELSE", "WHILE", "DO", "FOR", "BREAK",
  "CONTINUE", "RETURN_", "STATIC", "THIS", "EXPLICIT", "LIT", "PERM",
  "MODIFIER", "UNARY", "$accept", "file", "fileblock", "bareblock", "name",
  "runnable", "modifiers", "dec", "idpair", "idpairlist", "strid",
  "stridpair", "stridpairlist", "vardec", "barevardec", "type", "celltype",
  "dims", "dimexps", "decidlist", "decid", "decidstart", "varinit",
  "block", "arrayinit", "basearrayinit", "varinits", "formals",
  "baseformals", "formal", "fundec", "typedec", "value", "argument",
  "arglist", "basearglist", "exp", "join", "dir", "basicjoin", "tension",
  "controls", "stm", "stmexp", "blockstm", "forinit", "fortest",
  "forupdate", "stmexplist", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      43,   285,    45,    42,    47,    37,    94,   286,   287,   288,
     289,    63,   290,    58,   291,   292,   123,   293,   125,    40,
      41,    46,    44,    91,    93,    59,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    81,    82,    83,    83,    84,    84,    85,    85,    86,
      86,    86,    86,    87,    87,    87,    87,    88,    88,    88,
      88,    88,    88,    88,    88,    88,    88,    88,    88,    89,
      89,    90,    90,    91,    91,    92,    92,    93,    93,    94,
      95,    96,    96,    97,    98,    98,    99,    99,   100,   100,
     101,   101,   102,   102,   102,   102,   103,   103,   104,   105,
     105,   105,   105,   106,   106,   106,   107,   107,   108,   108,
     108,   109,   109,   110,   110,   110,   110,   110,   110,   111,
     111,   111,   112,   112,   113,   113,   113,   113,   113,   113,
     113,   113,   113,   114,   114,   115,   115,   115,   116,   116,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   118,   118,   118,   118,   118,
     119,   119,   119,   119,   120,   120,   120,   120,   120,   121,
     121,   121,   121,   122,   122,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   124,   125,   126,
     126,   126,   127,   127,   128,   128,   129,   129
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     0,     2,     0,     2,     1,     3,     1,
       1,     2,     2,     1,     1,     2,     2,     1,     1,     1,
       3,     5,     5,     3,     5,     5,     3,     3,     3,     1,
       3,     1,     3,     1,     1,     1,     3,     1,     3,     2,
       2,     1,     2,     1,     2,     3,     3,     4,     1,     3,
       1,     3,     1,     2,     3,     4,     1,     1,     3,     2,
       4,     3,     5,     1,     1,     2,     1,     3,     1,     3,
       2,     1,     3,     1,     2,     4,     2,     3,     5,     5,
       6,     6,     3,     2,     3,     4,     4,     3,     4,     3,
       4,     3,     1,     1,     3,     1,     3,     2,     1,     3,
       1,     1,     1,     1,     2,     4,     5,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     3,
       4,     3,     4,     5,     6,     6,     7,     5,     3,     5,
       7,    13,     3,     3,     2,     2,     2,     2,     3,     3,
       3,     3,     3,     3,     4,     1,     1,     2,     2,     3,
       4,     3,     5,     7,     1,     3,     3,     1,     1,     2,
       4,     3,     5,     2,     4,     1,     1,     2,     5,     7,
       5,     7,     9,     2,     2,     2,     3,     1,     1,     0,
       1,     1,     0,     1,     0,     1,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       3,     0,     2,     1,     7,     0,     0,     0,     0,     0,
     103,     5,     0,   175,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      92,   102,    14,    13,   100,     4,     0,     9,    17,     0,
       0,    41,   188,    18,    19,   101,   187,    10,     0,   176,
     100,   146,   145,   107,   108,   109,     0,   100,     0,    35,
      33,     0,    37,     0,     0,     0,     0,     0,     7,     0,
       0,     3,     0,    43,    83,     0,    43,   128,     0,     0,
       0,   189,   183,   184,   185,     0,   104,     0,     0,     0,
      42,    16,    15,    11,    12,    39,    52,     0,    40,    48,
      50,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     164,   167,   155,   147,   168,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   144,   156,   177,     0,
      58,     6,     0,     0,    91,     0,     0,     0,    20,    23,
      26,    27,    28,     0,     0,     0,    82,     0,    52,     0,
       0,   131,   129,     0,     0,     0,   191,   196,     0,   190,
     186,     7,    87,     0,    98,     0,    95,    93,     8,    44,
       0,     0,     0,    53,     0,     0,     0,    89,     0,    84,
       0,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   127,   123,   122,   120,   121,   116,   117,   118,   119,
     124,   110,   125,   111,   112,   113,   114,   115,   126,     0,
     138,     0,     0,   143,   142,   157,   158,   105,     0,     0,
      36,    38,    29,     0,    31,     0,     0,     0,   154,     0,
       0,     0,     0,    73,     0,    68,    71,     0,     0,     0,
     132,     0,   130,     0,     0,     0,   192,     0,     0,    97,
      88,     0,     0,    85,    45,    54,     0,     0,    49,    51,
      57,    56,    90,    86,   173,     0,   169,   165,   166,     0,
       0,   161,     0,   159,   106,   139,     0,     0,    22,     0,
      21,    25,    24,    54,     0,   133,    70,    76,    74,     0,
       0,     0,    46,    59,    63,     0,    66,     0,    64,     0,
       0,     0,   178,   180,     0,   193,     0,   197,    94,    99,
      96,    79,    55,     0,     0,   171,     0,   137,   160,     0,
       0,    30,    32,    55,    77,     0,   135,    72,    69,     0,
      61,     0,    65,   134,     0,    47,     0,     0,   194,    80,
      81,   174,     0,   170,   162,     0,   140,     0,     0,    75,
      60,     0,    67,   136,   179,   181,     0,   195,   172,     0,
       0,    78,    62,     0,   163,     0,   182,     0,     0,     0,
     141
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     1,     2,    56,    50,    35,    36,    37,   234,   235,
      61,    62,    63,    38,    39,   243,    41,    90,   162,    98,
      99,   100,   269,    42,   270,   307,   308,   244,   245,   246,
      43,    44,    45,   174,   175,   176,    46,   135,   136,   137,
     199,   200,    47,    48,    49,   168,   316,   366,   169
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -231
static const short int yypact[] =
{
    -231,    29,   476,  -231,  -231,   842,   842,   842,   842,   842,
    -231,  -231,   842,  -231,    12,   102,    12,    17,    19,    85,
     143,   102,   102,    92,   112,   618,   120,   135,   153,   164,
    -231,    10,  -231,  -231,    42,  -231,   547,  -231,  -231,   157,
      62,  -231,  -231,  -231,  -231,   105,  1967,  -231,   159,  -231,
     138,   173,   173,   173,   173,  -231,   328,   149,  1188,   192,
    -231,   212,  -231,   -25,     9,   162,   163,   167,   168,   -18,
     170,  -231,   178,    -1,  -231,   225,   180,    27,   842,   842,
     165,   842,  -231,  -231,  -231,   937,   173,   662,   233,   732,
     187,  -231,  -231,  -231,  -231,  -231,    30,   195,   193,  -231,
     210,   693,   251,   842,   842,   842,   842,   842,   842,   842,
     189,  -231,  -231,    10,  -231,   842,   842,   842,   842,   842,
     842,   842,   842,   842,   842,   842,   842,   842,   842,   842,
     842,   842,   842,   842,   701,   769,  -231,   209,  -231,   842,
    -231,  -231,   842,    -9,  -231,   842,   256,    12,  -231,  -231,
    -231,  -231,  -231,    20,    22,   405,  -231,   206,    41,    83,
     732,     8,   208,  1524,  1570,   213,  -231,  -231,   214,   211,
    -231,   223,  -231,   864,  -231,   217,    97,  1967,  -231,  -231,
     988,   218,    94,   187,    13,   225,   789,  -231,   226,  -231,
    1038,  1967,  1967,  1967,  1967,  1967,  1967,   842,   811,   257,
     267,     2,  2081,  2109,  2137,  2137,  2165,  2165,  2165,  2165,
    2201,   140,   413,   140,   173,   173,   173,   173,  2193,  1925,
    1967,   842,  1236,  -231,     2,   209,  -231,   173,   842,  1284,
    -231,  -231,   276,   229,  -231,   127,   232,   128,  -231,   154,
     178,    16,   102,   225,   238,   108,  -231,  1088,   234,   182,
    -231,   732,   187,   618,   618,   842,   842,   842,   842,  -231,
    -231,   864,   864,  -231,  -231,   178,   241,   242,  -231,  -231,
    -231,  1967,  -231,  -231,  1796,   842,  1839,  -231,  -231,   842,
    1708,  -231,   842,  -231,   173,  -231,   842,   290,  -231,   291,
    -231,  -231,  -231,  -231,   245,  -231,  -231,   225,   255,   178,
      16,    16,  -231,  -231,  -231,   789,  -231,   -17,   246,   178,
     252,  1138,   236,  -231,  1616,  1967,   249,  -231,  1967,  -231,
    -231,  -231,   178,   178,   842,  1882,   842,  2045,  -231,  1332,
    1380,  -231,  -231,  -231,   259,   789,  -231,  -231,  -231,   258,
    -231,   789,   789,  -231,   178,  -231,   618,   250,   842,  -231,
    -231,  2009,   842,  2009,  -231,   842,  -231,   842,   789,  -231,
    -231,   260,  -231,  -231,  -231,  -231,   263,   211,  2009,  1752,
    1428,  -231,  -231,   618,  -231,   842,  -231,  1476,   842,  1662,
    -231
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -231,  -231,   239,  -231,   130,   261,  -231,   271,    26,   166,
     298,   -11,  -231,   297,   243,     7,   300,   -15,  -231,  -231,
     141,  -229,  -170,   253,   171,  -231,  -231,  -172,  -231,  -230,
    -231,  -231,  -231,  -155,   222,  -231,    -5,  -231,  -116,   197,
    -231,  -231,   -19,   -73,  -102,  -231,  -231,  -231,   -20
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -44
static const short int yytable[] =
{
      51,    52,    53,    54,    55,    65,    80,    58,   167,    40,
     266,   296,   267,     4,   298,    59,     4,    94,   259,     4,
      66,   226,    68,   232,    85,   232,    86,   147,    75,     3,
     148,   340,   124,    88,   126,   127,   128,   129,   130,   341,
     153,   228,   143,    40,   181,   -43,   -43,     9,   134,    10,
      88,    60,   157,   233,   248,   236,    67,   249,    60,    12,
      88,   181,   161,    40,   149,    96,    97,   294,   334,   241,
     337,   338,    19,   163,   164,    22,   159,   310,   306,   182,
     160,   183,   177,   157,   180,    30,     4,    31,    75,   242,
     239,    87,   242,    88,   157,    89,   177,     4,   190,   191,
     192,   193,   194,   195,   196,     4,   319,   320,   201,   283,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   222,
     224,    71,    34,   240,   180,   339,   231,   227,   295,   241,
     229,    78,    57,   183,   265,    64,    72,   252,    69,   261,
     241,    73,    76,   262,   101,   247,   102,     4,   103,   242,
     300,    79,    40,   321,   301,   359,    34,     4,   177,    81,
     242,   361,   362,   127,   128,   129,   130,     5,     6,   289,
     289,   271,   290,   292,   317,     4,    34,    87,   371,    88,
      82,   139,   274,   276,     7,   -34,     8,   336,    87,   142,
      88,     9,    89,    10,   293,   197,   198,   343,    83,   130,
     241,    34,    95,    12,   138,   146,   280,   150,   151,    84,
     349,   350,   152,   284,    11,   -34,    19,   154,   158,    22,
     242,    88,   309,   165,   312,   313,   178,     4,   241,    30,
     181,    31,   363,   271,   184,   185,   311,     5,     6,   297,
     314,   315,   186,   318,   189,   134,   177,   177,   242,   230,
     179,   251,   255,   257,     7,   258,     8,   260,   277,   256,
     325,     9,   264,    10,   327,   167,   272,   329,   278,   287,
     248,   330,   303,    12,   288,    34,   304,   291,   299,    73,
     305,   322,   323,   331,   232,   333,    19,   335,   342,    22,
     271,   358,   344,   346,   348,   365,   360,    93,   372,    30,
     155,    31,    73,   373,    73,   332,    70,   141,    74,   351,
     237,   353,    77,   188,   166,   156,   268,   364,   367,     0,
     271,     4,   250,   225,     0,     0,   271,   271,     0,     0,
       0,     5,     6,     0,     0,     0,     0,   368,     0,     0,
     369,     0,   370,   271,   376,     0,     0,     0,     7,     0,
       8,     0,     0,     0,     0,     9,     0,    10,     0,    73,
     377,    73,    73,   379,    11,     0,   140,    12,     0,    73,
       0,     0,     0,    13,     0,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,     0,    24,    25,    26,    27,
      28,    29,     0,    30,     0,    31,    32,    33,     4,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     5,     6,
       0,     0,     0,     0,   110,   111,   112,   113,   114,     0,
      73,    73,     0,     0,     0,     7,     0,     8,     0,     0,
       0,     0,     9,   124,    10,   126,   127,   128,   129,   130,
       0,    11,     0,   238,    12,     0,     0,     0,     0,   134,
      13,     0,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,     0,    24,    25,    26,    27,    28,    29,     4,
      30,     0,    31,    32,    33,     0,     0,     0,     0,     5,
       6,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     7,     0,     8,     0,
       0,     0,     0,     9,     0,    10,     0,     0,     0,     0,
       0,     0,    11,     0,     0,    12,     0,     0,     0,     0,
       0,    13,     0,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,     0,    24,    25,    26,    27,    28,    29,
       4,    30,     0,    31,    32,    33,     0,     0,     0,     0,
       5,     6,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     7,     0,     8,
       0,     0,     0,     0,     9,     0,    10,     0,     0,     0,
       0,     0,     0,    11,     0,     0,    12,     0,     0,     0,
       0,     0,    13,     0,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,     0,    24,    25,    26,    27,    28,
      29,     4,    30,     0,    31,    91,    92,     0,     0,     0,
       0,     5,     6,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     7,     0,
       8,     0,     0,     0,     0,     9,     0,    10,     0,     0,
       0,     0,     0,     0,    11,   171,     0,    12,     0,     0,
       0,     0,     0,    13,     0,     5,     6,     0,     0,     0,
      19,     0,     0,    22,    23,     0,    24,    25,    26,    27,
      28,    29,     7,    30,     8,    31,   171,     0,     0,     9,
       0,    10,     0,     0,     4,     0,     5,     6,     0,     0,
       0,    12,   172,     0,     5,     6,     0,     0,   173,     0,
     221,     0,     0,     7,    19,     8,     0,    22,     0,     0,
       9,     7,    10,     8,     0,     4,     0,    30,     9,    31,
      10,     0,    12,   187,     0,     5,     6,     0,     0,   173,
      12,     0,     0,     0,     0,    19,     0,     0,    22,     0,
       0,     0,     7,    19,     8,     0,    22,     0,    30,     9,
      31,    10,     4,     0,     0,     0,    30,     0,    31,     0,
       0,    12,     5,     6,     0,     0,   179,     0,     0,   223,
       0,     0,     4,     0,    19,     0,     0,    22,     0,     7,
       0,     8,     5,     6,     0,     0,     9,    30,    10,    31,
       0,     0,     0,     0,     4,     0,     0,     0,    12,     7,
       0,     8,     0,     0,     5,     6,     9,     0,    10,   275,
       0,    19,     0,     0,    22,   248,     0,     0,    12,     0,
       0,     7,     0,     8,    30,     4,    31,     0,     9,     0,
      10,    19,     0,     0,    22,     5,     6,     0,     0,     0,
      12,     0,     0,     0,    30,     0,    31,   171,     0,     0,
       0,     0,     7,    19,     8,     0,    22,     5,     6,     9,
       0,    10,     0,     0,     0,     0,    30,     0,    31,     0,
       0,    12,     0,     0,     7,     0,     8,     0,     0,     0,
       0,     9,     0,    10,    19,     0,     0,    22,     0,     0,
       0,     0,     0,    12,     0,     0,     0,    30,     0,    31,
       0,     0,     0,     0,     0,     0,    19,     0,     0,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    30,
       0,    31,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,     0,     0,     0,     0,     0,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,     0,   131,     0,     0,   132,   133,
       0,     0,     0,   134,     0,     0,     0,     0,     0,     0,
       0,     0,   170,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,     0,     0,     0,     0,     0,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,     0,   131,     0,     0,   132,
     133,     0,     0,     0,   134,     0,     0,     0,     0,     0,
       0,     0,   263,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,     0,     0,     0,     0,     0,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,     0,   131,     0,     0,   132,
     133,     0,     0,     0,   134,     0,     0,     0,     0,     0,
       0,     0,   273,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,     0,     0,     0,     0,     0,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,     0,   131,     0,     0,   132,
     133,     0,     0,     0,   134,     0,     0,     0,     0,     0,
       0,     0,   302,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,     0,     0,     0,     0,     0,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,     0,   131,     0,     0,   132,
     133,     0,     0,     0,   134,     0,     0,     0,     0,     0,
       0,     0,   345,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,     0,     0,     0,     0,     0,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,     0,   131,     0,     0,   132,
     133,     0,     0,     0,   134,     0,     0,     0,   144,     0,
     145,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,     0,     0,     0,     0,     0,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,     0,   131,     0,     0,   132,   133,     0,
       0,     0,   134,     0,   281,     0,     0,     0,   282,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
       0,     0,     0,     0,     0,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,     0,   131,     0,     0,   132,   133,     0,     0,     0,
     134,     0,     0,     0,   285,     0,   286,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,     0,     0,
       0,     0,     0,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,     0,
     131,     0,     0,   132,   133,     0,     0,     0,   134,     0,
     354,     0,     0,     0,   355,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,     0,     0,     0,     0,
       0,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,     0,   131,     0,
       0,   132,   133,     0,     0,     0,   134,     0,     0,     0,
     356,     0,   357,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,     0,     0,     0,     0,     0,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,     0,   131,     0,     0,   132,
     133,     0,     0,     0,   134,     0,     0,     0,     0,     0,
     375,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,     0,     0,     0,     0,     0,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,     0,   131,     0,     0,   132,   133,     0,
       0,     0,   134,     0,     0,     0,     0,     0,   378,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
       0,     0,     0,     0,     0,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,     0,   131,     0,     0,   132,   133,     0,     0,     0,
     134,     0,     0,     0,   253,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,     0,     0,     0,     0,
       0,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,     0,   131,     0,
       0,   132,   133,     0,     0,     0,   134,     0,     0,     0,
     254,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,     0,     0,     0,     0,     0,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,     0,   131,     0,     0,   132,   133,     0,
       0,     0,   134,     0,     0,     0,   347,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,     0,     0,
       0,     0,     0,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,     0,
     131,     0,     0,   132,   133,     0,     0,     0,   134,     0,
       0,     0,   380,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,     0,     0,     0,     0,     0,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,     0,   131,     0,     0,   132,
     133,     0,     0,     0,   134,     0,   328,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,     0,     0,
       0,     0,     0,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,     0,
     131,     0,     0,   132,   133,     0,     0,     0,   134,     0,
     374,   104,   105,   106,   107,   108,   109,     0,   111,   112,
     113,   114,     0,     0,     0,     0,     0,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,     0,   131,     0,     0,   132,   133,     0,
       0,     0,   134,   324,   104,   105,   106,   107,   108,   109,
       0,   111,   112,   113,   114,     0,     0,     0,     0,     0,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,     0,   131,     0,     0,
     132,   133,     0,     0,     0,   134,   326,   104,   105,   106,
     107,   108,   109,     0,   111,   112,   113,   114,     0,     0,
       0,     0,     0,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,     0,
     131,     0,     0,   132,   133,     0,     0,     0,   134,   352,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,     0,     0,     0,     0,     0,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,     0,   131,     0,     0,   132,   133,   279,     0,
       0,   134,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,     0,     0,     0,     0,     0,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,     0,   131,     0,     0,   132,   133,
       0,     0,     0,   134,   104,   105,   106,   107,   108,   109,
       0,   111,   112,   113,   114,     0,     0,     0,     0,     0,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,     0,   131,     0,     0,
     132,   133,     0,     0,     0,   134,   110,   111,   112,   113,
     114,     0,     0,     0,     0,     0,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,     0,   131,     0,     0,   132,     0,     0,     0,
       0,   134,   110,   111,   112,   113,   114,     0,     0,     0,
       0,     0,     0,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,     0,   131,
     110,   111,   112,   113,   114,     0,     0,   134,     0,     0,
       0,     0,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,     0,   131,   110,   111,
     112,   113,   114,     0,     0,   134,     0,     0,     0,     0,
       0,     0,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,     0,   131,   110,   111,   112,   113,
     114,     0,     0,   134,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   123,   124,   125,   126,   127,   128,
     129,   130,     0,   131,   110,   111,   112,   113,   114,     0,
       0,   134,   110,   111,   112,   113,   114,     0,     0,     0,
       0,     0,   123,   124,   125,   126,   127,   128,   129,   130,
       0,   124,   125,   126,   127,   128,   129,   130,     0,   134,
       0,     0,     0,     0,     0,     0,     0,   134
};

static const short int yycheck[] =
{
       5,     6,     7,     8,     9,    16,    25,    12,    81,     2,
     182,   241,   184,     3,   243,     3,     3,    36,   173,     3,
       3,   137,     3,     3,    29,     3,    31,    52,    21,     0,
      55,    48,    30,    51,    32,    33,    34,    35,    36,    56,
      58,    50,    57,    36,    53,     3,     4,    37,    46,    39,
      51,    39,    53,    33,    46,    33,    39,    49,    39,    49,
      51,    53,    77,    56,    55,     3,     4,   239,   297,    56,
     300,   301,    62,    78,    79,    65,    49,   249,   248,    49,
      53,    96,    87,    53,    89,    75,     3,    77,    81,    76,
      49,    49,    76,    51,    53,    53,   101,     3,   103,   104,
     105,   106,   107,   108,   109,     3,   261,   262,   113,   225,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,    46,     2,    50,   139,   305,   147,   142,   240,    56,
     145,    49,    12,   158,    50,    15,     3,   162,    18,    52,
      56,    21,    22,    56,    49,   160,    51,     3,    53,    76,
      52,    49,   155,   265,    56,   335,    36,     3,   173,    49,
      76,   341,   342,    33,    34,    35,    36,    13,    14,    52,
      52,   186,    55,    55,   257,     3,    56,    49,   358,    51,
      55,    53,   197,   198,    30,     3,    32,   299,    49,    50,
      51,    37,    53,    39,    50,    16,    17,   309,    55,    36,
      56,    81,    55,    49,    55,     3,   221,    55,    55,    55,
     322,   323,    55,   228,    46,    57,    62,    57,     3,    65,
      76,    51,    50,    68,   253,   254,     3,     3,    56,    75,
      53,    77,   344,   248,    49,    52,   251,    13,    14,   242,
     255,   256,    42,   258,     3,    46,   261,   262,    76,     3,
      54,    53,    49,    52,    30,    42,    32,    50,    11,    55,
     275,    37,    54,    39,   279,   348,    50,   282,    11,     3,
      46,   286,    48,    49,    55,   155,    52,    55,    50,   159,
      56,    50,    50,     3,     3,    50,    62,    42,    52,    65,
     305,    42,    50,    67,    55,    55,    48,    36,    48,    75,
      71,    77,   182,    50,   184,   289,    18,    56,    21,   324,
     154,   326,    22,   101,    81,    72,   185,   346,   348,    -1,
     335,     3,   161,   136,    -1,    -1,   341,   342,    -1,    -1,
      -1,    13,    14,    -1,    -1,    -1,    -1,   352,    -1,    -1,
     355,    -1,   357,   358,   373,    -1,    -1,    -1,    30,    -1,
      32,    -1,    -1,    -1,    -1,    37,    -1,    39,    -1,   239,
     375,   241,   242,   378,    46,    -1,    48,    49,    -1,   249,
      -1,    -1,    -1,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    -1,    68,    69,    70,    71,
      72,    73,    -1,    75,    -1,    77,    78,    79,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    13,    14,
      -1,    -1,    -1,    -1,    11,    12,    13,    14,    15,    -1,
     300,   301,    -1,    -1,    -1,    30,    -1,    32,    -1,    -1,
      -1,    -1,    37,    30,    39,    32,    33,    34,    35,    36,
      -1,    46,    -1,    48,    49,    -1,    -1,    -1,    -1,    46,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    -1,    68,    69,    70,    71,    72,    73,     3,
      75,    -1,    77,    78,    79,    -1,    -1,    -1,    -1,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    -1,    32,    -1,
      -1,    -1,    -1,    37,    -1,    39,    -1,    -1,    -1,    -1,
      -1,    -1,    46,    -1,    -1,    49,    -1,    -1,    -1,    -1,
      -1,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    -1,    68,    69,    70,    71,    72,    73,
       3,    75,    -1,    77,    78,    79,    -1,    -1,    -1,    -1,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    -1,    32,
      -1,    -1,    -1,    -1,    37,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    46,    -1,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    -1,    68,    69,    70,    71,    72,
      73,     3,    75,    -1,    77,    78,    79,    -1,    -1,    -1,
      -1,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    -1,
      32,    -1,    -1,    -1,    -1,    37,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    -1,    46,     3,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    55,    -1,    13,    14,    -1,    -1,    -1,
      62,    -1,    -1,    65,    66,    -1,    68,    69,    70,    71,
      72,    73,    30,    75,    32,    77,     3,    -1,    -1,    37,
      -1,    39,    -1,    -1,     3,    -1,    13,    14,    -1,    -1,
      -1,    49,    50,    -1,    13,    14,    -1,    -1,    56,    -1,
      19,    -1,    -1,    30,    62,    32,    -1,    65,    -1,    -1,
      37,    30,    39,    32,    -1,     3,    -1,    75,    37,    77,
      39,    -1,    49,    50,    -1,    13,    14,    -1,    -1,    56,
      49,    -1,    -1,    -1,    -1,    62,    -1,    -1,    65,    -1,
      -1,    -1,    30,    62,    32,    -1,    65,    -1,    75,    37,
      77,    39,     3,    -1,    -1,    -1,    75,    -1,    77,    -1,
      -1,    49,    13,    14,    -1,    -1,    54,    -1,    -1,    20,
      -1,    -1,     3,    -1,    62,    -1,    -1,    65,    -1,    30,
      -1,    32,    13,    14,    -1,    -1,    37,    75,    39,    77,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    49,    30,
      -1,    32,    -1,    -1,    13,    14,    37,    -1,    39,    18,
      -1,    62,    -1,    -1,    65,    46,    -1,    -1,    49,    -1,
      -1,    30,    -1,    32,    75,     3,    77,    -1,    37,    -1,
      39,    62,    -1,    -1,    65,    13,    14,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    75,    -1,    77,     3,    -1,    -1,
      -1,    -1,    30,    62,    32,    -1,    65,    13,    14,    37,
      -1,    39,    -1,    -1,    -1,    -1,    75,    -1,    77,    -1,
      -1,    49,    -1,    -1,    30,    -1,    32,    -1,    -1,    -1,
      -1,    37,    -1,    39,    62,    -1,    -1,    65,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    75,    -1,    77,
      -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    77,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    -1,    38,    -1,    -1,    41,    42,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    55,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    38,    -1,    -1,    41,
      42,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    54,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    38,    -1,    -1,    41,
      42,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    54,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    38,    -1,    -1,    41,
      42,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    54,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    38,    -1,    -1,    41,
      42,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    54,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    38,    -1,    -1,    41,
      42,    -1,    -1,    -1,    46,    -1,    -1,    -1,    50,    -1,
      52,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    38,    -1,    -1,    41,    42,    -1,
      -1,    -1,    46,    -1,    48,    -1,    -1,    -1,    52,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    -1,    38,    -1,    -1,    41,    42,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    50,    -1,    52,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    -1,
      38,    -1,    -1,    41,    42,    -1,    -1,    -1,    46,    -1,
      48,    -1,    -1,    -1,    52,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    -1,    38,    -1,
      -1,    41,    42,    -1,    -1,    -1,    46,    -1,    -1,    -1,
      50,    -1,    52,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    38,    -1,    -1,    41,
      42,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      52,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    38,    -1,    -1,    41,    42,    -1,
      -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    -1,    38,    -1,    -1,    41,    42,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    50,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    -1,    38,    -1,
      -1,    41,    42,    -1,    -1,    -1,    46,    -1,    -1,    -1,
      50,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    38,    -1,    -1,    41,    42,    -1,
      -1,    -1,    46,    -1,    -1,    -1,    50,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    -1,
      38,    -1,    -1,    41,    42,    -1,    -1,    -1,    46,    -1,
      -1,    -1,    50,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    38,    -1,    -1,    41,
      42,    -1,    -1,    -1,    46,    -1,    48,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    -1,
      38,    -1,    -1,    41,    42,    -1,    -1,    -1,    46,    -1,
      48,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    38,    -1,    -1,    41,    42,    -1,
      -1,    -1,    46,    47,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    -1,    38,    -1,    -1,
      41,    42,    -1,    -1,    -1,    46,    47,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    -1,
      38,    -1,    -1,    41,    42,    -1,    -1,    -1,    46,    47,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    38,    -1,    -1,    41,    42,    43,    -1,
      -1,    46,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    -1,    38,    -1,    -1,    41,    42,
      -1,    -1,    -1,    46,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    -1,    38,    -1,    -1,
      41,    42,    -1,    -1,    -1,    46,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    38,    -1,    -1,    41,    -1,    -1,    -1,
      -1,    46,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    -1,    38,
      11,    12,    13,    14,    15,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    -1,    38,    11,    12,
      13,    14,    15,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    -1,    38,    11,    12,    13,    14,
      15,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    38,    11,    12,    13,    14,    15,    -1,
      -1,    46,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    29,    30,    31,    32,    33,    34,    35,    36,
      -1,    30,    31,    32,    33,    34,    35,    36,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    46
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    82,    83,     0,     3,    13,    14,    30,    32,    37,
      39,    46,    49,    55,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    68,    69,    70,    71,    72,    73,
      75,    77,    78,    79,    85,    86,    87,    88,    94,    95,
      96,    97,   104,   111,   112,   113,   117,   123,   124,   125,
      85,   117,   117,   117,   117,   117,    84,    85,   117,     3,
      39,    91,    92,    93,    85,    92,     3,    39,     3,    85,
      91,    46,     3,    85,    94,    96,    85,    97,    49,    49,
     123,    49,    55,    55,    55,   117,   117,    49,    51,    53,
      98,    78,    79,    88,   123,    55,     3,     4,   100,   101,
     102,    49,    51,    53,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    38,    41,    42,    46,   118,   119,   120,    55,    53,
      48,    86,    50,    98,    50,    52,     3,    52,    55,    55,
      55,    55,    55,    58,    57,    83,   104,    53,     3,    49,
      53,    98,    99,   117,   117,    68,    95,   124,   126,   129,
      55,     3,    50,    56,   114,   115,   116,   117,     3,    54,
     117,    53,    49,    98,    49,    52,    42,    50,   115,     3,
     117,   117,   117,   117,   117,   117,   117,    16,    17,   121,
     122,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,    19,   117,    20,   117,   120,   119,   117,    50,   117,
       3,    92,     3,    33,    89,    90,    33,    90,    48,    49,
      50,    56,    76,    96,   108,   109,   110,   117,    46,    49,
     105,    53,    98,    50,    50,    49,    55,    52,    42,   114,
      50,    52,    56,    54,    54,    50,   108,   108,   101,   103,
     105,   117,    50,    54,   117,    18,   117,    11,    11,    43,
     117,    48,    52,   119,   117,    50,    52,     3,    55,    52,
      55,    55,    55,    50,   108,   125,   110,    96,   102,    50,
      52,    56,    54,    48,    52,    56,   103,   106,   107,    50,
     108,   117,   123,   123,   117,   117,   127,   124,   117,   114,
     114,   125,    50,    50,    47,   117,    47,   117,    48,   117,
     117,     3,    89,    50,   102,    42,   125,   110,   110,   103,
      48,    56,    52,   125,    50,    54,    67,    50,    55,   125,
     125,   117,    47,   117,    48,    52,    50,    52,    42,   103,
      48,   103,   103,   125,   123,    55,   128,   129,   117,   117,
     117,   103,    48,    50,    48,    52,   123,   117,    52,   117,
      50
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  yyvsp[0] = yylval;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 167 "camp.y"
    { absyntax::root = (yyvsp[0].b); ;}
    break;

  case 3:
#line 171 "camp.y"
    { (yyval.b) = new file(lexerPos(), false); ;}
    break;

  case 4:
#line 173 "camp.y"
    { (yyval.b) = (yyvsp[-1].b); (yyval.b)->add((yyvsp[0].run)); ;}
    break;

  case 5:
#line 177 "camp.y"
    { (yyval.b) = new block(lexerPos(), true); ;}
    break;

  case 6:
#line 179 "camp.y"
    { (yyval.b) = (yyvsp[-1].b); (yyval.b)->add((yyvsp[0].run)); ;}
    break;

  case 7:
#line 183 "camp.y"
    { (yyval.n) = new simpleName((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 8:
#line 184 "camp.y"
    { (yyval.n) = new qualifiedName((yyvsp[-1].pos), (yyvsp[-2].n), (yyvsp[0].ps).sym); ;}
    break;

  case 9:
#line 197 "camp.y"
    { (yyval.run) = (yyvsp[0].d); ;}
    break;

  case 10:
#line 198 "camp.y"
    { (yyval.run) = (yyvsp[0].s); ;}
    break;

  case 11:
#line 200 "camp.y"
    { (yyval.run) = new modifiedRunnable((yyvsp[-1].ml)->getPos(), (yyvsp[-1].ml), (yyvsp[0].d)); ;}
    break;

  case 12:
#line 202 "camp.y"
    { (yyval.run) = new modifiedRunnable((yyvsp[-1].ml)->getPos(), (yyvsp[-1].ml), (yyvsp[0].s)); ;}
    break;

  case 13:
#line 206 "camp.y"
    { (yyval.ml) = new modifierList((yyvsp[0].mod).pos); (yyval.ml)->add((yyvsp[0].mod).val); ;}
    break;

  case 14:
#line 207 "camp.y"
    { (yyval.ml) = new modifierList((yyvsp[0].perm).pos); (yyval.ml)->add((yyvsp[0].perm).val); ;}
    break;

  case 15:
#line 209 "camp.y"
    { (yyval.ml) = (yyvsp[-1].ml); (yyval.ml)->add((yyvsp[0].mod).val); ;}
    break;

  case 16:
#line 211 "camp.y"
    { (yyval.ml) = (yyvsp[-1].ml); (yyval.ml)->add((yyvsp[0].perm).val); ;}
    break;

  case 17:
#line 215 "camp.y"
    { (yyval.d) = (yyvsp[0].vd); ;}
    break;

  case 18:
#line 216 "camp.y"
    { (yyval.d) = (yyvsp[0].d); ;}
    break;

  case 19:
#line 217 "camp.y"
    { (yyval.d) = (yyvsp[0].d); ;}
    break;

  case 20:
#line 219 "camp.y"
    { (yyval.d) = new accessdec((yyvsp[-2].pos), (yyvsp[-1].ipl)); ;}
    break;

  case 21:
#line 221 "camp.y"
    { (yyval.d) = new unraveldec((yyvsp[-4].pos), (yyvsp[-3].n), (yyvsp[-1].ipl)); ;}
    break;

  case 22:
#line 223 "camp.y"
    { (yyval.d) = new unraveldec((yyvsp[-4].pos), (yyvsp[-3].n), WILDCARD); ;}
    break;

  case 23:
#line 224 "camp.y"
    { (yyval.d) = new unraveldec((yyvsp[-2].pos), (yyvsp[-1].n), WILDCARD); ;}
    break;

  case 24:
#line 226 "camp.y"
    { (yyval.d) = new fromaccessdec((yyvsp[-4].pos), (yyvsp[-3].ps).sym, (yyvsp[-1].ipl)); ;}
    break;

  case 25:
#line 228 "camp.y"
    { (yyval.d) = new fromaccessdec((yyvsp[-4].pos), (yyvsp[-3].ps).sym, WILDCARD); ;}
    break;

  case 26:
#line 230 "camp.y"
    { (yyval.d) = new importdec((yyvsp[-2].pos), (yyvsp[-1].ip)); ;}
    break;

  case 27:
#line 231 "camp.y"
    { (yyval.d) = new includedec((yyvsp[-2].pos), (yyvsp[-1].ps).sym); ;}
    break;

  case 28:
#line 233 "camp.y"
    { (yyval.d) = new includedec((yyvsp[-2].pos), (mem::string)*(yyvsp[-1].ps).sym); ;}
    break;

  case 29:
#line 237 "camp.y"
    { (yyval.ip) = new idpair((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 30:
#line 239 "camp.y"
    { (yyval.ip) = new idpair((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym, (yyvsp[-1].ps).sym , (yyvsp[0].ps).sym); ;}
    break;

  case 31:
#line 243 "camp.y"
    { (yyval.ipl) = new idpairlist(); (yyval.ipl)->add((yyvsp[0].ip)); ;}
    break;

  case 32:
#line 245 "camp.y"
    { (yyval.ipl) = (yyvsp[-2].ipl); (yyval.ipl)->add((yyvsp[0].ip)); ;}
    break;

  case 33:
#line 249 "camp.y"
    { (yyval.ps) = (yyvsp[0].ps); ;}
    break;

  case 34:
#line 250 "camp.y"
    { (yyval.ps) = (yyvsp[0].ps); ;}
    break;

  case 35:
#line 254 "camp.y"
    { (yyval.ip) = new idpair((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 36:
#line 256 "camp.y"
    { (yyval.ip) = new idpair((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym, (yyvsp[-1].ps).sym , (yyvsp[0].ps).sym); ;}
    break;

  case 37:
#line 260 "camp.y"
    { (yyval.ipl) = new idpairlist(); (yyval.ipl)->add((yyvsp[0].ip)); ;}
    break;

  case 38:
#line 262 "camp.y"
    { (yyval.ipl) = (yyvsp[-2].ipl); (yyval.ipl)->add((yyvsp[0].ip)); ;}
    break;

  case 39:
#line 266 "camp.y"
    { (yyval.vd) = (yyvsp[-1].vd); ;}
    break;

  case 40:
#line 270 "camp.y"
    { (yyval.vd) = new vardec((yyvsp[-1].t)->getPos(), (yyvsp[-1].t), (yyvsp[0].dil)); ;}
    break;

  case 41:
#line 274 "camp.y"
    { (yyval.t) = (yyvsp[0].t); ;}
    break;

  case 42:
#line 279 "camp.y"
    { (yyval.t) = new arrayTy((yyvsp[-1].n), (yyvsp[0].dim)); ;}
    break;

  case 43:
#line 283 "camp.y"
    { (yyval.t) = new nameTy((yyvsp[0].n)); ;}
    break;

  case 44:
#line 289 "camp.y"
    { (yyval.dim) = new dimensions((yyvsp[-1].pos)); ;}
    break;

  case 45:
#line 290 "camp.y"
    { (yyval.dim) = (yyvsp[-2].dim); (yyval.dim)->increase(); ;}
    break;

  case 46:
#line 294 "camp.y"
    { (yyval.elist) = new explist((yyvsp[-2].pos)); (yyval.elist)->add((yyvsp[-1].e)); ;}
    break;

  case 47:
#line 296 "camp.y"
    { (yyval.elist) = (yyvsp[-3].elist); (yyval.elist)->add((yyvsp[-1].e)); ;}
    break;

  case 48:
#line 300 "camp.y"
    { (yyval.dil) = new decidlist((yyvsp[0].di)->getPos()); (yyval.dil)->add((yyvsp[0].di)); ;}
    break;

  case 49:
#line 302 "camp.y"
    { (yyval.dil) = (yyvsp[-2].dil); (yyval.dil)->add((yyvsp[0].di)); ;}
    break;

  case 50:
#line 306 "camp.y"
    { (yyval.di) = new decid((yyvsp[0].dis)->getPos(), (yyvsp[0].dis)); ;}
    break;

  case 51:
#line 308 "camp.y"
    { (yyval.di) = new decid((yyvsp[-2].dis)->getPos(), (yyvsp[-2].dis), (yyvsp[0].vi)); ;}
    break;

  case 52:
#line 312 "camp.y"
    { (yyval.dis) = new decidstart((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 53:
#line 313 "camp.y"
    { (yyval.dis) = new decidstart((yyvsp[-1].ps).pos, (yyvsp[-1].ps).sym, (yyvsp[0].dim)); ;}
    break;

  case 54:
#line 314 "camp.y"
    { (yyval.dis) = new fundecidstart((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym, 0,
                                            new formals((yyvsp[-1].pos))); ;}
    break;

  case 55:
#line 317 "camp.y"
    { (yyval.dis) = new fundecidstart((yyvsp[-3].ps).pos, (yyvsp[-3].ps).sym, 0, (yyvsp[-1].fls)); ;}
    break;

  case 56:
#line 321 "camp.y"
    { (yyval.vi) = (yyvsp[0].e); ;}
    break;

  case 57:
#line 322 "camp.y"
    { (yyval.vi) = (yyvsp[0].ai); ;}
    break;

  case 58:
#line 327 "camp.y"
    { (yyval.b) = (yyvsp[-1].b); ;}
    break;

  case 59:
#line 331 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[-1].pos)); ;}
    break;

  case 60:
#line 333 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[-3].pos)); (yyval.ai)->addRest((yyvsp[-1].vi)); ;}
    break;

  case 61:
#line 335 "camp.y"
    { (yyval.ai) = (yyvsp[-1].ai); ;}
    break;

  case 62:
#line 337 "camp.y"
    { (yyval.ai) = (yyvsp[-3].ai); (yyval.ai)->addRest((yyvsp[-1].vi)); ;}
    break;

  case 63:
#line 341 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[0].pos)); ;}
    break;

  case 64:
#line 342 "camp.y"
    { (yyval.ai) = (yyvsp[0].ai); ;}
    break;

  case 65:
#line 343 "camp.y"
    { (yyval.ai) = (yyvsp[-1].ai); ;}
    break;

  case 66:
#line 347 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[0].vi)->getPos());
		     (yyval.ai)->add((yyvsp[0].vi));;}
    break;

  case 67:
#line 350 "camp.y"
    { (yyval.ai) = (yyvsp[-2].ai); (yyval.ai)->add((yyvsp[0].vi)); ;}
    break;

  case 68:
#line 354 "camp.y"
    { (yyval.fls) = (yyvsp[0].fls); ;}
    break;

  case 69:
#line 356 "camp.y"
    { (yyval.fls) = (yyvsp[-2].fls); (yyval.fls)->addRest((yyvsp[0].fl)); ;}
    break;

  case 70:
#line 357 "camp.y"
    { (yyval.fls) = new formals((yyvsp[-1].pos)); (yyval.fls)->addRest((yyvsp[0].fl)); ;}
    break;

  case 71:
#line 361 "camp.y"
    { (yyval.fls) = new formals((yyvsp[0].fl)->getPos()); (yyval.fls)->add((yyvsp[0].fl)); ;}
    break;

  case 72:
#line 363 "camp.y"
    { (yyval.fls) = (yyvsp[-2].fls); (yyval.fls)->add((yyvsp[0].fl)); ;}
    break;

  case 73:
#line 367 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].t)->getPos(), (yyvsp[0].t)); ;}
    break;

  case 74:
#line 368 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].dis)->getPos(), (yyvsp[-1].t), (yyvsp[0].dis)); ;}
    break;

  case 75:
#line 370 "camp.y"
    { (yyval.fl) = new formal((yyvsp[-2].dis)->getPos(), (yyvsp[-3].t), (yyvsp[-2].dis), (yyvsp[0].vi)); ;}
    break;

  case 76:
#line 372 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].t)->getPos(), (yyvsp[0].t), 0, 0, true); ;}
    break;

  case 77:
#line 374 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].dis)->getPos(), (yyvsp[-1].t), (yyvsp[0].dis), 0, true); ;}
    break;

  case 78:
#line 376 "camp.y"
    { (yyval.fl) = new formal((yyvsp[-2].dis)->getPos(), (yyvsp[-3].t), (yyvsp[-2].dis), (yyvsp[0].vi), true); ;}
    break;

  case 79:
#line 381 "camp.y"
    { (yyval.d) = new fundec((yyvsp[-2].pos), (yyvsp[-4].t), (yyvsp[-3].ps).sym, new formals((yyvsp[-2].pos)), (yyvsp[0].s)); ;}
    break;

  case 80:
#line 383 "camp.y"
    { (yyval.d) = new fundec((yyvsp[-3].pos), (yyvsp[-5].t), (yyvsp[-4].ps).sym, (yyvsp[-2].fls), (yyvsp[0].s)); ;}
    break;

  case 81:
#line 385 "camp.y"
    { (yyval.d) = new fundec((yyvsp[-3].pos), (yyvsp[-5].t), (yyvsp[-4].ps).sym, (yyvsp[-2].fls), (yyvsp[0].s)); ;}
    break;

  case 82:
#line 389 "camp.y"
    { (yyval.d) = new recorddec((yyvsp[-2].pos), (yyvsp[-1].ps).sym, (yyvsp[0].b)); ;}
    break;

  case 83:
#line 390 "camp.y"
    { (yyval.d) = new typedec((yyvsp[-1].pos), (yyvsp[0].vd)); ;}
    break;

  case 84:
#line 395 "camp.y"
    { (yyval.e) = new fieldExp((yyvsp[-1].pos), (yyvsp[-2].e), (yyvsp[0].ps).sym); ;}
    break;

  case 85:
#line 396 "camp.y"
    { (yyval.e) = new subscriptExp((yyvsp[-2].pos),
                              new nameExp((yyvsp[-3].n)->getPos(), (yyvsp[-3].n)), (yyvsp[-1].e)); ;}
    break;

  case 86:
#line 398 "camp.y"
    { (yyval.e) = new subscriptExp((yyvsp[-2].pos), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 87:
#line 399 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-1].pos),
                                      new nameExp((yyvsp[-2].n)->getPos(), (yyvsp[-2].n)),
                                      new arglist()); ;}
    break;

  case 88:
#line 403 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-2].pos), 
                                      new nameExp((yyvsp[-3].n)->getPos(), (yyvsp[-3].n)),
                                      (yyvsp[-1].alist)); ;}
    break;

  case 89:
#line 406 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-1].pos), (yyvsp[-2].e), new arglist()); ;}
    break;

  case 90:
#line 408 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-2].pos), (yyvsp[-3].e), (yyvsp[-1].alist)); ;}
    break;

  case 91:
#line 411 "camp.y"
    { (yyval.e) = (yyvsp[-1].e); ;}
    break;

  case 92:
#line 412 "camp.y"
    { (yyval.e) = new thisExp((yyvsp[0].pos)); ;}
    break;

  case 93:
#line 416 "camp.y"
    { (yyval.arg).name=0;      (yyval.arg).val=(yyvsp[0].e); ;}
    break;

  case 94:
#line 417 "camp.y"
    { (yyval.arg).name=(yyvsp[-2].ps).sym; (yyval.arg).val=(yyvsp[0].e); ;}
    break;

  case 95:
#line 421 "camp.y"
    { (yyval.alist) = (yyvsp[0].alist); ;}
    break;

  case 96:
#line 423 "camp.y"
    { (yyval.alist) = (yyvsp[-2].alist); (yyval.alist)->rest = (yyvsp[0].arg); ;}
    break;

  case 97:
#line 424 "camp.y"
    { (yyval.alist) = new arglist(); (yyval.alist)->rest = (yyvsp[0].arg); ;}
    break;

  case 98:
#line 428 "camp.y"
    { (yyval.alist) = new arglist(); (yyval.alist)->add((yyvsp[0].arg)); ;}
    break;

  case 99:
#line 430 "camp.y"
    { (yyval.alist) = (yyvsp[-2].alist); (yyval.alist)->add((yyvsp[0].arg)); ;}
    break;

  case 100:
#line 442 "camp.y"
    { (yyval.e) = new nameExp((yyvsp[0].n)->getPos(), (yyvsp[0].n)); ;}
    break;

  case 101:
#line 443 "camp.y"
    { (yyval.e) = (yyvsp[0].e); ;}
    break;

  case 102:
#line 444 "camp.y"
    { (yyval.e) = (yyvsp[0].e); ;}
    break;

  case 103:
#line 445 "camp.y"
    { (yyval.e) = new stringExp((yyvsp[0].ps).pos, *(yyvsp[0].ps).sym); ;}
    break;

  case 104:
#line 447 "camp.y"
    { (yyval.e) = new scaleExp((yyvsp[-1].e)->getPos(), (yyvsp[-1].e), (yyvsp[0].e)); ;}
    break;

  case 105:
#line 452 "camp.y"
    { (yyval.e) = new castExp((yyvsp[-2].n)->getPos(), new nameTy((yyvsp[-2].n)), (yyvsp[0].e)); ;}
    break;

  case 106:
#line 456 "camp.y"
    { (yyval.e) = new castExp((yyvsp[-3].n)->getPos(), new arrayTy((yyvsp[-3].n), (yyvsp[-2].dim)), (yyvsp[0].e)); ;}
    break;

  case 107:
#line 458 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 108:
#line 460 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 109:
#line 461 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 110:
#line 462 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 111:
#line 463 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 112:
#line 464 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 113:
#line 465 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 114:
#line 466 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 115:
#line 467 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 116:
#line 468 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 117:
#line 469 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 118:
#line 470 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 119:
#line 471 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 120:
#line 472 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 121:
#line 473 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 122:
#line 474 "camp.y"
    { (yyval.e) = new andExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 123:
#line 475 "camp.y"
    { (yyval.e) = new orExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 124:
#line 476 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 125:
#line 477 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 126:
#line 478 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 127:
#line 479 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 128:
#line 481 "camp.y"
    { (yyval.e) = new newRecordExp((yyvsp[-1].pos), (yyvsp[0].t)); ;}
    break;

  case 129:
#line 487 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-2].pos), (yyvsp[-1].t), (yyvsp[0].elist), 0, 0); ;}
    break;

  case 130:
#line 489 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-3].pos), (yyvsp[-2].t), (yyvsp[-1].elist), (yyvsp[0].dim), 0); ;}
    break;

  case 131:
#line 491 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-2].pos), (yyvsp[-1].t), 0, (yyvsp[0].dim), 0); ;}
    break;

  case 132:
#line 493 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-3].pos), (yyvsp[-2].t), 0, (yyvsp[-1].dim), (yyvsp[0].ai)); ;}
    break;

  case 133:
#line 495 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-4].pos), (yyvsp[-3].t), new formals((yyvsp[-2].pos)), (yyvsp[0].s)); ;}
    break;

  case 134:
#line 497 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-5].pos),
                                             new arrayTy((yyvsp[-4].t)->getPos(), (yyvsp[-4].t), (yyvsp[-3].dim)),
                                             new formals((yyvsp[-2].pos)),
                                             (yyvsp[0].s)); ;}
    break;

  case 135:
#line 502 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-5].pos), (yyvsp[-4].t), (yyvsp[-2].fls), (yyvsp[0].s)); ;}
    break;

  case 136:
#line 504 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-6].pos),
                                             new arrayTy((yyvsp[-5].t)->getPos(), (yyvsp[-5].t), (yyvsp[-4].dim)),
                                             (yyvsp[-2].fls),
                                             (yyvsp[0].s)); ;}
    break;

  case 137:
#line 509 "camp.y"
    { (yyval.e) = new conditionalExp((yyvsp[-3].pos), (yyvsp[-4].e), (yyvsp[-2].e), (yyvsp[0].e)); ;}
    break;

  case 138:
#line 510 "camp.y"
    { (yyval.e) = new assignExp((yyvsp[-1].pos), (yyvsp[-2].e), (yyvsp[0].e)); ;}
    break;

  case 139:
#line 513 "camp.y"
    { (yyval.e) = new pairExp((yyvsp[-4].pos), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 140:
#line 515 "camp.y"
    { (yyval.e) = new tripleExp((yyvsp[-6].pos), (yyvsp[-5].e), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 141:
#line 517 "camp.y"
    { (yyval.e) = new transformExp((yyvsp[-12].pos), (yyvsp[-11].e), (yyvsp[-9].e), (yyvsp[-7].e), (yyvsp[-5].e), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 142:
#line 519 "camp.y"
    { (yyvsp[-1].j)->pushFront((yyvsp[-2].e)); (yyvsp[-1].j)->pushBack((yyvsp[0].e)); (yyval.e) = (yyvsp[-1].j); ;}
    break;

  case 143:
#line 521 "camp.y"
    { (yyvsp[-1].j)->pushFront((yyvsp[-2].e));
                     (yyvsp[-1].j)->pushBack(new nullaryExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym));
                     (yyval.e) = (yyvsp[-1].j) ;}
    break;

  case 144:
#line 525 "camp.y"
    { (yyvsp[0].se)->setSide(camp::OUT);
                     joinExp *jexp =
                         new joinExp((yyvsp[0].se)->getPos(), symbol::trans(".."));
                     (yyval.e)=jexp;
                     jexp->pushBack((yyvsp[-1].e)); jexp->pushBack((yyvsp[0].se)); ;}
    break;

  case 145:
#line 531 "camp.y"
    { (yyval.e) = new prefixExp((yyvsp[-1].ps).pos, (yyvsp[0].e), symbol::trans("+")); ;}
    break;

  case 146:
#line 533 "camp.y"
    { (yyval.e) = new prefixExp((yyvsp[-1].ps).pos, (yyvsp[0].e), symbol::trans("-")); ;}
    break;

  case 147:
#line 536 "camp.y"
    { (yyval.e) = new postfixExp((yyvsp[0].ps).pos, (yyvsp[-1].e), symbol::trans("+")); ;}
    break;

  case 148:
#line 537 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 149:
#line 539 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 150:
#line 540 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 151:
#line 541 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 152:
#line 542 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 153:
#line 544 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 154:
#line 546 "camp.y"
    { (yyval.e) = new quoteExp((yyvsp[-3].pos), (yyvsp[-1].b)); ;}
    break;

  case 155:
#line 552 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos,(yyvsp[0].ps).sym); ;}
    break;

  case 156:
#line 554 "camp.y"
    { (yyval.j) = (yyvsp[0].j); ;}
    break;

  case 157:
#line 556 "camp.y"
    { (yyvsp[-1].se)->setSide(camp::OUT);
                     (yyval.j) = (yyvsp[0].j); (yyval.j)->pushFront((yyvsp[-1].se)); ;}
    break;

  case 158:
#line 559 "camp.y"
    { (yyvsp[0].se)->setSide(camp::IN);
                     (yyval.j) = (yyvsp[-1].j); (yyval.j)->pushBack((yyvsp[0].se)); ;}
    break;

  case 159:
#line 562 "camp.y"
    { (yyvsp[-2].se)->setSide(camp::OUT); (yyvsp[0].se)->setSide(camp::IN);
                     (yyval.j) = (yyvsp[-1].j); (yyval.j)->pushFront((yyvsp[-2].se)); (yyval.j)->pushBack((yyvsp[0].se)); ;}
    break;

  case 160:
#line 567 "camp.y"
    { (yyval.se) = new specExp((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym, (yyvsp[-1].e)); ;}
    break;

  case 161:
#line 568 "camp.y"
    { (yyval.se) = new specExp((yyvsp[-2].pos), symbol::opTrans("spec"), (yyvsp[-1].e)); ;}
    break;

  case 162:
#line 570 "camp.y"
    { (yyval.se) = new specExp((yyvsp[-4].pos), symbol::opTrans("spec"),
				      new pairExp((yyvsp[-2].pos), (yyvsp[-3].e), (yyvsp[-1].e))); ;}
    break;

  case 163:
#line 573 "camp.y"
    { (yyval.se) = new specExp((yyvsp[-6].pos), symbol::opTrans("spec"),
				      new tripleExp((yyvsp[-4].pos), (yyvsp[-5].e), (yyvsp[-3].e), (yyvsp[-1].e))); ;}
    break;

  case 164:
#line 578 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 165:
#line 580 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym); (yyval.j)->pushBack((yyvsp[-1].e)); ;}
    break;

  case 166:
#line 582 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym); (yyval.j)->pushBack((yyvsp[-1].e)); ;}
    break;

  case 167:
#line 583 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 168:
#line 584 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 169:
#line 588 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym,
                              new booleanExp((yyvsp[-1].ps).pos, false)); ;}
    break;

  case 170:
#line 591 "camp.y"
    { (yyval.e) = new ternaryExp((yyvsp[-3].ps).pos, (yyvsp[-2].e), (yyvsp[-3].ps).sym, (yyvsp[0].e),
                              new booleanExp((yyvsp[-3].ps).pos, false)); ;}
    break;

  case 171:
#line 594 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-2].ps).pos, (yyvsp[0].e), (yyvsp[-2].ps).sym,
                              new booleanExp((yyvsp[-1].ps).pos, true)); ;}
    break;

  case 172:
#line 597 "camp.y"
    { (yyval.e) = new ternaryExp((yyvsp[-4].ps).pos, (yyvsp[-2].e), (yyvsp[-4].ps).sym, (yyvsp[0].e),
                              new booleanExp((yyvsp[-3].ps).pos, true)); ;}
    break;

  case 173:
#line 602 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 174:
#line 604 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-3].ps).pos, (yyvsp[-2].e), (yyvsp[-3].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 175:
#line 608 "camp.y"
    { (yyval.s) = new emptyStm((yyvsp[0].pos)); ;}
    break;

  case 176:
#line 609 "camp.y"
    { (yyval.s) = (yyvsp[0].s); ;}
    break;

  case 177:
#line 610 "camp.y"
    { (yyval.s) = (yyvsp[-1].s); ;}
    break;

  case 178:
#line 612 "camp.y"
    { (yyval.s) = new ifStm((yyvsp[-4].pos), (yyvsp[-2].e), (yyvsp[0].s)); ;}
    break;

  case 179:
#line 614 "camp.y"
    { (yyval.s) = new ifStm((yyvsp[-6].pos), (yyvsp[-4].e), (yyvsp[-2].s), (yyvsp[0].s)); ;}
    break;

  case 180:
#line 616 "camp.y"
    { (yyval.s) = new whileStm((yyvsp[-4].pos), (yyvsp[-2].e), (yyvsp[0].s)); ;}
    break;

  case 181:
#line 618 "camp.y"
    { (yyval.s) = new doStm((yyvsp[-6].pos), (yyvsp[-5].s), (yyvsp[-2].e)); ;}
    break;

  case 182:
#line 620 "camp.y"
    { (yyval.s) = new forStm((yyvsp[-8].pos), (yyvsp[-6].run), (yyvsp[-4].e), (yyvsp[-2].sel), (yyvsp[0].s)); ;}
    break;

  case 183:
#line 621 "camp.y"
    { (yyval.s) = new breakStm((yyvsp[-1].pos)); ;}
    break;

  case 184:
#line 622 "camp.y"
    { (yyval.s) = new continueStm((yyvsp[-1].pos)); ;}
    break;

  case 185:
#line 623 "camp.y"
    { (yyval.s) = new returnStm((yyvsp[-1].pos)); ;}
    break;

  case 186:
#line 624 "camp.y"
    { (yyval.s) = new returnStm((yyvsp[-2].pos), (yyvsp[-1].e)); ;}
    break;

  case 187:
#line 628 "camp.y"
    { (yyval.s) = new expStm((yyvsp[0].e)->getPos(), (yyvsp[0].e)); ;}
    break;

  case 188:
#line 632 "camp.y"
    { (yyval.s) = new blockStm((yyvsp[0].b)->getPos(), (yyvsp[0].b)); ;}
    break;

  case 189:
#line 636 "camp.y"
    { (yyval.run) = 0; ;}
    break;

  case 190:
#line 637 "camp.y"
    { (yyval.run) = (yyvsp[0].sel); ;}
    break;

  case 191:
#line 638 "camp.y"
    { (yyval.run) = (yyvsp[0].vd); ;}
    break;

  case 192:
#line 642 "camp.y"
    { (yyval.e) = 0; ;}
    break;

  case 193:
#line 643 "camp.y"
    { (yyval.e) = (yyvsp[0].e); ;}
    break;

  case 194:
#line 647 "camp.y"
    { (yyval.sel) = 0; ;}
    break;

  case 195:
#line 648 "camp.y"
    { (yyval.sel) = (yyvsp[0].sel); ;}
    break;

  case 196:
#line 652 "camp.y"
    { (yyval.sel) = new stmExpList((yyvsp[0].s)->getPos()); (yyval.sel)->add((yyvsp[0].s)); ;}
    break;

  case 197:
#line 654 "camp.y"
    { (yyval.sel) = (yyvsp[-2].sel); (yyval.sel)->add((yyvsp[0].s)); ;}
    break;


    }

/* Line 1037 of yacc.c.  */
#line 2950 "camp.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {

		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 yydestruct ("Error: popping",
                             yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yydestruct ("Error: discarding lookahead",
              yytoken, &yylval);
  yychar = YYEMPTY;
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}



